Difference tool generates invalid geometries

2015-09-16 07:44 AM - Jos Ferraro

Status: Closed

Priority: Low

Assignee:

Category: Processing/QGIS

Affected QGIS version:2.8.3 Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution: end of life

Crashes QGIS or corrupts data:No Copied to github as #: 21420

Description

When using the Difference... tool on two layers with valid geometries, QGIS produces a layer with invalid geometries.

To reproduce, use the attached file:

i) open layers minizona13 and retalho

ii) use Check Geometry Validity to verify that there is no error before

iii) use Difference... with layer retalho as Input and minizona13  as Difference

iv) use Check Geometry Validity to verify that there an error on the created layer

The difference that I get goes attached as well under tghe name difff_errada13

History

#1 - 2015-09-16 03:02 PM - Saber Razmjooei

- File geo_minizona.PNG added

- Status changed from Open to Closed

- Resolution set to invalid

There is a gap between FID 1 and FID 3 and hence the difference comes up with the small polygons.

#2 - 2015-09-16 03:05 PM - Jos Ferraro

there may sure be a gap, but is it a valid reason to produce an invalid geometry?

I understand that if I operate on valid geometries the result should be valid no matter what. I don't care if the result has small polygons(I may actually want

that) but I would like valid ones.

#3 - 2015-09-16 03:23 PM - Saber Razmjooei

- Resolution deleted (invalid)

- Priority changed from Normal to Low

- Status changed from Closed to Reopened

#4 - 2015-09-16 11:48 PM - Jukka Rahkonen

This is the faulty geometry as WKT and it is a polygon which has a hole outside the shell. It should be either two distinct polygons or a multipolygon with two

parts. JTS, GEOS, and QGIS itself is reporting it as invalid. It is also hard to correct by digitizing because the hole should be converted into another

polygon feature.

POLYGON ((

        -43.206147 -22.908303, 
        -43.207488 -22.908866, 

        -43.208452 -22.909126, 

        -43.207489 -22.908866, 

        -43.206147 -22.908303

    ), (

        -43.209573 -22.909271, 

        -43.20957519759788 -22.90923750003237, 

        -43.20957519759788 -22.909237500032372, 

        -43.209573 -22.909271

    ))

#5 - 2015-09-17 04:41 PM - Jamie Portman

We experience similar issues when using the 'Avoid Intersection' function.

We start with perfectly valid geometries, but when QGIS creates the new feature applying the rules, it allows itself to generate invalid geometries.

#6 - 2017-01-02 05:50 AM - Giovanni Manghi

- Category changed from 44 to Processing/QGIS

#7 - 2017-05-01 01:06 AM - Giovanni Manghi

- Regression? set to No

- Easy fix? set to No

#8 - 2019-03-09 03:12 PM - Giovanni Manghi

- Resolution set to end of life

- Status changed from Reopened to Closed

End of life notice: QGIS 2.18 LTR

Source:

http://blog.qgis.org/2019/03/09/end-of-life-notice-qgis-2-18-ltr/

Files

difference_invalid.rar 26.8 KB 2015-09-16 Jos Ferraro

geo_minizona.PNG 16.8 KB 2015-09-16 Saber Razmjooei
